// MQL5-code

class BACKTEST
  {
public:
   //  true,    OnTick()    NewTick   -  .  - false.
   static bool BACKTEST::IsEnding(void)
     {
      return(::TesterStatistics(STAT_BALANCEMIN) > 0);
     }

   //    (     "Balance max")
   static double BACKTEST::Balance(void)
     {
      return(BACKTEST::IsEnding() ? ::TesterStatistics(STAT_INITIAL_DEPOSIT) +
                                    ::TesterStatistics(STAT_WITHDRAWAL) +
                                    ::TesterStatistics(STAT_PROFIT) : ::AccountInfoDouble(ACCOUNT_BALANCE));
     }

   //  true,    " "   .  - false.
   static bool BACKTEST::IsNotWithdrawalAfter(void)
     {
      return(BACKTEST::IsEnding() && (::MathAbs(BACKTEST::Balance() - ::AccountInfoDouble(ACCOUNT_BALANCE)) < 0.005));
     }

   //    
   static bool BACKTEST::CorrectFinishBalance(const double Value)
     {
      return(BACKTEST::IsNotWithdrawalAfter() ? ::TesterWithdrawal(Value) : false);
     }
  };
//+------------------------------------------------------------------+
